// AMcmdHelp.cpp: implementation of the AMcmdHelp class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AMcmdHelp.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AMcmdHelp::AMcmdHelp()
{

}

AMcmdHelp::~AMcmdHelp()
{

}

AMcmdHelp::AMcmdHelp(AMcmd* parent)
{
	m_parent = parent;
}

int AMcmdHelp::Parse(AMcmd* parent)
{
	unsigned int i;
	m_parent = parent;

	switch(m_parent->m_argc)
	{
	case 0:
		Error(AMPERR_FATAL);
		return AMPERR_FATAL;

	case 1:
		DisplayHelp();
		break;

	default:
		// Warning(AMPERR_EXCESS_PARAM);
		// fall through

	case 2:
		{
			AMcmd *p;
			int found = 0;
			i = 0; while (i < m_parent->GetCmdCount())
			{
				p = m_parent->GetCmd(i);
				if (!STRINGCOMPARE(p->GetName(), m_parent->GetParam(1), 2048))
				{
					p->DisplayHelp();
					found = 1;
					break;
				}
				i++;
			}
			if (found == 0)
			{
				TCHAR msg[4096];
				PRINTSTRING(msg, _T("Command %s not found\n"), m_parent->GetParam(1));
				PRINTTERM(msg);
			}
		}
		break;
	}

	return 0;
}

TCHAR* AMcmdHelp::GetName()
{
	return _T("HELP");
}


void AMcmdHelp::DisplayHelp()
{
	unsigned int i;

	PRINTTERM(_T("Commands available:\n"));
	for (i = 0; i < m_parent->GetCmdCount(); i++)
	{
		PRINTTERM(m_parent->GetCmd(i)->GetName());
		PRINTTERM(_T("\n"));
	}

	PRINTTERM(_T("To get help on command X, type HELP X\n"));
	PRINTTERM(_T("To cancel a prompt, press CTRL-HOME, CTRL-Z, ENTER\n"));
}
