// AMcmdShowLog.cpp: implementation of the AMcmdShowLog class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AMcmdShowLog.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AMcmdShowLog::AMcmdShowLog()
{

}

AMcmdShowLog::~AMcmdShowLog()
{

}

AMcmdShowLog::AMcmdShowLog(AMcmd* parent)
{
	m_parent = parent;
}

int AMcmdShowLog::Parse(AMcmd* parent)
{
	m_parent = parent;

	Execute();

	return 0;
}

TCHAR* AMcmdShowLog::GetName()
{
	return _T("SHOWLOG");
}

void AMcmdShowLog::DisplayHelp()
{
	PRINTTERM(_T("ShowLog has no parameters\n"));
}

int AMcmdShowLog::Execute()
{
	LOG p[AM_BULKSIZE];
	TCHAR b[2048];
	TCHAR txt[256];
	AMRETURN rc;
	U32 mm = AM_BULKSIZE;
	U32 n, m;

	mm = 10;
	rc = theDbc.LogQueryFirst(mm, NULL, 0, NULL, AMCOLNAM_CREA _T(" DESC"), p, &n);

	while (n > 0)
	{
		for (U32 j = 0; j < n; j++)
		{
			STRINGCOPY(b, _T(""));
			StringCat(b, p[j].created, 20); 
			StringCat(b, (TCHAR*)p[j].createdBy, 10);

			m = 4;
			if (p[j].status == AM_SUCCESS)
			{
				StringCat(b, _T("Ok"), m);
			}	
			else
			{
				PRINTSTRING(txt, _T("%d"), p[j].status);
				StringCat(b, txt, m);
			}

			m = 10;
			switch(p[j].action)
			{
			case AM_LOGON:
				StringCat(b, _T("LOGON"), m);
				break;
			case AM_LOGOFF:
				StringCat(b, _T("LOGOFF"), m);
				break;
			case AM_RESET:
				StringCat(b, _T("RESET"), m);
				break;
			case AM_INSERT:
				StringCat(b, _T("INSERT"), m);
				break;
			case AM_DELETE:
				StringCat(b, _T("DELETE"), m);
				break;
			case AM_UPDATE:
				StringCat(b, _T("UPDATE"), m);
				break;
			case AM_ENABLE:
				StringCat(b, _T("ENABLE"), m);
				break;
			case AM_DISABLE:
				StringCat(b, _T("DISABLE"), m);
				break;
			}

			m = 4;
			switch(p[j].operand)
			{
			case AM_USER:
				StringCat(b, _T("USER"), m);
				break;
			case AM_GRUP:
				StringCat(b, _T("GRUP"), m);
				break;
			case AM_NTUS:
				StringCat(b, _T("NTUS"), m);
				break;
			case AM_NTGR:
				StringCat(b, _T("NTGR"), m);
				break;
			case AM_WKST:
				StringCat(b, _T("WKST"), m);
				break;
			case AM_DOMN:
				StringCat(b, _T("DOMN"), m);
				break;
			case AM_ROLE:
				StringCat(b, _T("ROLE"), m);
				break;
			case AM_MAIN:
				StringCat(b, _T("MAIN"), m);
				break;
			case AM_LOG:
				StringCat(b, _T("LOG"), m);
				break;
			case AM_ALL:
				StringCat(b, _T("ALL"), m);
				break;
			default:
				PRINTSTRING(txt, _T("%d"), p[j].operand);
				StringCat(b, txt, m);
				break;
			}

			StringCat(b, p[j].p1, 20); 
			/*
			PRINTSTRING(txt, _T("0x%8.8x "), p[j].operat);
			StringCat(b, txt, 10);
			StringCat(b, p[j].p2, 20);
			StringCat(b, p[j].p3, 20);
			*/
			STRINGCAT(b, _T("\n"));

			PRINTTERM(b);
		}

		rc = theDbc.LogQueryNext(mm, p, &n);
		if (n > 0)
		{
			PRINTTERM(_T("More> "));
			if (!READTERM(p[0].p1)) n = 0;
			if (STRINGCOMPARE(p[0].p1, _T(""), 1)) n = 0;
		}
	}

	Error(rc); // no more data is also an "error"

	return rc;
}

void AMcmdShowLog::Error(int err)
{
	switch (err)
	{
	case AM_ERR_NOT_LOGGED_ON:
		PRINTTERM (_T("You are not logged on\n"));
		break;
	case AM_NO_MORE_DATA:
		PRINTTERM (_T("List complete\n"));
		break;
	default:
		PRINTTERM (_T("Error %d\n"), err);
		break;
	}
}
