// AMconnection.h: interface for the AMconnection class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AMCONNECTION_H__E4AEE478_0C48_11D4_BD6C_329F76000000__INCLUDED_)
#define AFX_AMCONNECTION_H__E4AEE478_0C48_11D4_BD6C_329F76000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef void (WINAPI *PD3HLPWRITELOG)(TCHAR*);
typedef unsigned int (WINAPI *PD3HLPCALCULATECHECK) (TCHAR*, unsigned short, TCHAR*);

#include "AMroot.h"

#ifdef AMLIB_EXPORTS
#include "AMrole.h"
#else
#include <DBIodbc.h>
#endif

class AMLIB_API AMconnection : public AMroot  
{
public:
	AMRETURN SetDebug(AMBOOL debug);
	AMBOOL GetDebug();
	PD3HLPWRITELOG m_pWriteLog;
	PD3HLPCALCULATECHECK m_pMd5;
	AMconnection();
	~AMconnection();
	AMBOOL IsLoggedOn();

	AMRETURN CheckTables();
	AMRETURN ClearLog();
	AMRETURN ClearTodo();
	AMRETURN ClearRoleAssignments();
	AMRETURN CreateDefaultTables();
	AMRETURN WriteLog(TCHAR *txt);
	AMRETURN SetLogCallback(void*, void*);
	AMRETURN FireAlarm(U32 severity, U32 type, TCHAR *txt);
	AMRETURN SetAlarmCallback(void*, void*);
	AMRETURN Logoff();
	AMRETURN Logon(TCHAR *dsn, TCHAR *uid, TCHAR *pwd);

	AMRETURN RoleInsert(TCHAR *time, ROLE *p);
	AMRETURN RoleInsertNow(ROLE *p);
	AMRETURN RoleUpdate(TCHAR* datim, ROLE *p);
	AMRETURN RoleUpdateNow(ROLE *p);
	AMRETURN RoleDelete(TCHAR *datim, ROLE *p);
	AMRETURN RoleDeleteNow(ROLE *p);
	AMRETURN RoleQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, ROLE *p, U32 *n);
	AMRETURN RoleQueryNext(U32 num, ROLE *p, U32 *n);

	AMRETURN NetOpUserInsert(TCHAR *time, NUSER *p);
	AMRETURN NetOpUserInsertNow(NUSER *p);
	AMRETURN NetOpUserUpdate(TCHAR* datim, NUSER *p);
	AMRETURN NetOpUserUpdateNow(NUSER *p);
	AMRETURN NetOpUserUpdatePasswordNow(TCHAR *user, TCHAR *oldpwd, TCHAR *newpwd);
	AMRETURN NetOpUserNullifyPasswordNow(TCHAR *user);
	AMRETURN NetOpUserDelete(TCHAR *datim, NUSER *p);
	AMRETURN NetOpUserDeleteNow(NUSER *p);
	AMRETURN NetOpUserQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, NUSER *p, U32 *n);
	AMRETURN NetOpUserQueryNext(U32 num, NUSER *p, U32 *n);

	AMRETURN NetOpUserQueryGroups(U32 id, U32 num, NGROUP *p, U32 *n);
	AMRETURN NetOpUserAddToGroup(U32 id, U32 groupID);
	AMRETURN NetOpUserRemoveFromGroup(U32 id, U32 groupID);
	AMBOOL NetOpUserVerify(U32);

	AMRETURN NetOpHostInsert(TCHAR *time, NHOST *p);
	AMRETURN NetOpHostInsertNow(NHOST *p);
	AMRETURN NetOpHostUpdate(TCHAR* datim, NHOST *p);
	AMRETURN NetOpHostUpdateNow(NHOST *p);
	AMRETURN NetOpHostDelete(TCHAR *datim, NHOST *p);
	AMRETURN NetOpHostDeleteNow(NHOST *p);
	AMRETURN NetOpHostQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, NHOST *p, U32 *n);
	AMRETURN NetOpHostQueryNext(U32 num, NHOST *p, U32 *n);

	AMRETURN NetOpHostQueryGroups(U32 id, U32 num, NGROUP *p, U32 *n);
	AMRETURN NetOpHostAddToGroup(U32 id, U32 groupID);
	AMRETURN NetOpHostRemoveFromGroup(U32 id, U32 groupID);
	AMBOOL NetOpHostVerify(U32);

	AMRETURN NetOpGroupInsert(TCHAR *time, U32 type, NGROUP *p);
	AMRETURN NetOpGroupInsertNow(U32 type, NGROUP *p);
	AMRETURN NetOpGroupUpdate(TCHAR* datim, U32 type, NGROUP *p);
	AMRETURN NetOpGroupUpdateNow(U32 type, NGROUP *p);
	AMRETURN NetOpGroupEnable(TCHAR* datim, U32 type, NGROUP *p, AMBOOL yesno);
	AMRETURN NetOpGroupEnableNow(U32 type, NGROUP *p, AMBOOL yesno);
	AMRETURN NetOpGroupDelete(TCHAR *datim, U32 type, NGROUP *p);
	AMRETURN NetOpGroupDeleteNow(U32 type, NGROUP *p);
	AMRETURN NetOpGroupQueryFirst(U32 type, U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, NGROUP *p, U32 *n);
	AMRETURN NetOpGroupQueryNext(U32 type, U32 num, NGROUP *p, U32 *n);

	AMRETURN NetOpGroupQueryUsersFirst(U32 id, U32 num, NUSER *p, U32 *n);
	AMRETURN NetOpGroupQueryUsersNext(U32 num, NUSER *p, U32 *n);
	AMBOOL NetOpUserGroupVerify(U32);

	AMRETURN NetOpGroupQueryHostsFirst(U32 id, U32 num, NHOST *p, U32 *n);
	AMRETURN NetOpGroupQueryHostsNext(U32 num, NHOST *p, U32 *n);
	AMBOOL NetOpHostGroupVerify(U32);

	AMRETURN NtUserInsert(TCHAR *time, NTUSER *p);
	AMRETURN NtUserInsertNow(NTUSER *p);
	AMRETURN NtUserUpdate(TCHAR* datim, NTUSER *p);
	AMRETURN NtUserUpdateNow(NTUSER *p);
	AMRETURN NtUserDelete(TCHAR *datim, NTUSER *p);
	AMRETURN NtUserDeleteNow(NTUSER *p);
	AMRETURN NtUserQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, NTUSER *p, U32 *n);
	AMRETURN NtUserQueryNext(U32 num, NTUSER *p, U32 *n);

	AMRETURN NtGroupInsert(TCHAR *time, NTGROUP *p);
	AMRETURN NtGroupInsertNow(NTGROUP *p);
	AMRETURN NtGroupUpdate(TCHAR* datim, NTGROUP *p);
	AMRETURN NtGroupUpdateNow(NTGROUP *p);
	AMRETURN NtGroupEnable(TCHAR* datim, NTGROUP *p, AMBOOL yesno);
	AMRETURN NtGroupEnableNow(NTGROUP *p, AMBOOL yesno);
	AMRETURN NtGroupDelete(TCHAR *datim, NTGROUP *p);
	AMRETURN NtGroupDeleteNow(NTGROUP *p);
	AMRETURN NtGroupQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, NTGROUP *p, U32 *n);
	AMRETURN NtGroupQueryNext(U32 num, NTGROUP *p, U32 *n);

	AMRETURN DomainInsert(TCHAR *time, AMDOMAIN *p);
	AMRETURN DomainInsertNow(AMDOMAIN *p);
	AMRETURN DomainUpdate(TCHAR* datim, AMDOMAIN *p);
	AMRETURN DomainUpdateNow(AMDOMAIN *p);
	AMRETURN DomainDelete(TCHAR *datim, AMDOMAIN *p);
	AMRETURN DomainDeleteNow(AMDOMAIN *p);
	AMRETURN DomainQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, AMDOMAIN *p, U32 *n);
	AMRETURN DomainQueryNext(U32 num, AMDOMAIN *p, U32 *n);

	AMRETURN ServerInsert(TCHAR *time, AMSERVER *p);
	AMRETURN ServerInsertNow(AMSERVER *p);
	AMRETURN ServerUpdate(TCHAR* datim, AMSERVER *p);
	AMRETURN ServerUpdateNow(AMSERVER *p);
	AMRETURN ServerUpdateRunField(AMSERVER *p);
	AMRETURN ServerDelete(TCHAR *datim, AMSERVER *p);
	AMRETURN ServerDeleteNow(AMSERVER *p);
	AMRETURN ServerQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, AMSERVER *p, U32 *n);
	AMRETURN ServerQueryNext(U32 num, AMSERVER *p, U32 *n);

	AMRETURN WorkstationInsert(TCHAR *time, WKST *p);
	AMRETURN WorkstationInsertNow(WKST *p);
	AMRETURN WorkstationUpdate(TCHAR* datim, WKST *p);
	AMRETURN WorkstationUpdateNow(WKST *p);
	AMRETURN WorkstationDelete(TCHAR *datim, WKST *p);
	AMRETURN WorkstationDeleteNow(WKST *p);
	AMRETURN WorkstationQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, WKST *p, U32 *n);
	AMRETURN WorkstationQueryNext(U32 num, WKST *p, U32 *n);

	AMRETURN RoleAssignmentInsert(TCHAR *time, MAIN *p);
	AMRETURN RoleAssignmentInsertNow(MAIN *p);
	AMRETURN RoleAssignmentUpdate(TCHAR* datim, MAIN *p);
	AMRETURN RoleAssignmentUpdateNow(MAIN *p);
	AMRETURN RoleAssignmentDelete(TCHAR *datim, MAIN *p);
	AMRETURN RoleAssignmentDeleteNow(MAIN *p);
	AMRETURN RoleAssignmentQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, MAIN *p, U32 *n);
	AMRETURN RoleAssignmentQueryNext(U32 num, MAIN *p, U32 *n);
	AMRETURN RoleAssignmentQueryHostsFirst(U32 num, U32 GuestType, U32 GuestID, MAIN *p, U32 *n);
	AMRETURN RoleAssignmentQueryGuestsFirst(U32 num, U32 HostType, U32 HostID, MAIN *p, U32 *n);

	AMRETURN ConnectionInsertNow(CONN *p);
	AMRETURN ConnectionDeleteNow(CONN *p);
	AMRETURN ConnectionQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, CONN *p, U32 *n);
	AMRETURN ConnectionQueryNext(U32 num, CONN *p, U32 *n);

	AMRETURN LogQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, LOG *p, U32 *n);
	AMRETURN LogQueryNext(U32 num, LOG *p, U32 *n);
	AMRETURN LogDelete(TCHAR*);
	AMRETURN LogInsert(U32 action, U32 operand, U32 operat, TCHAR *p1, TCHAR *p2, TCHAR *p3, AMRETURN rc);

	AMRETURN EventLogQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, AMEVNT *p, U32 *n);
	AMRETURN EventLogQueryNext(U32 num, AMEVNT *p, U32 *n);
	AMRETURN EventLogDelete(TCHAR*);
	AMRETURN EventLogInsert(AMEVNT*);

	// All handling of the todo table is immediate
	AMRETURN StartNewBatch(U32);
	AMRETURN BatchInsert(BATCH *p);
	AMRETURN BatchUpdate(BATCH *p);
	AMRETURN BatchDelete(BATCH *p);
	AMRETURN BatchQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, BATCH *p, U32 *n);
	AMRETURN BatchQueryNext(U32 num, BATCH *p, U32 *n);
	AMRETURN TodoInsert(SCHEDULE *p);
	AMRETURN TodoDelete(SCHEDULE *p);
	AMRETURN TodoDeleteBatch(U32 batch);
	AMRETURN TodoQueryFirst(U32 num, TCHAR *col, U32 cond, TCHAR *like, TCHAR *orderby, SCHEDULE *p, U32 *n);
	AMRETURN TodoQueryNext(U32 num, SCHEDULE *p, U32 *n);

	// Extern users of these should make sure to rollback or commit befor calling any other functions
	AMRETURN Rollback();
	AMRETURN Commit();
	AMRETURN BeginTransaction();

	// Functions which return accumulated rights
	U32 RightsQuery(U32 guestType, TCHAR* guestName, U32 hostType, TCHAR* hostName, TCHAR *pwd, DB_FEATURELIST *feat);
	DBIodbc m_db;
	void Dc(TCHAR*);

protected:
	TCHAR m_user[AM_DBUSRLEN];
	AM_MSG_FUNC m_msgFunc;
	AM_ALARM_FUNC m_alarmFunc;
	void *m_this;
	void *m_thisAlarm;
	U32 m_querytype;
	BOOL m_transact;
	U32 m_guesttype;
	TCHAR m_guestname[AM_PARAMLEN];
	U32 m_hosttype;
	TCHAR m_hostname[AM_PARAMLEN];
	TCHAR* GetNow();
	TCHAR m_feat[14];
private:
	AMBOOL m_isResetting;
	void Ec(TCHAR*);
	U32 RightsQueryError(U32);
	AMBOOL WrongPassword(TCHAR*, TCHAR*);
	U32 DateDiff(TCHAR*, TCHAR*);
	U32 DateToNum(U32 year, U32 month, U32 day);
	void FeatureListInit(DB_FEATURELIST*);
	U32 FeatureListPostProc(DB_FEATURELIST*);
	U32 RightsQueryUserHost(TCHAR*, TCHAR*, DB_FEATURELIST*);
	U32 RightsQueryUserNuser(TCHAR*, TCHAR*, DB_FEATURELIST*);
	U32 RightsQueryUserWkst(TCHAR*, TCHAR*, DB_FEATURELIST*);
	U32 RightsQueryNuserWkst(TCHAR*, TCHAR*, TCHAR*, TCHAR*, DB_FEATURELIST*);
	U32 RightsQueryNuserNuser(TCHAR*, TCHAR*, TCHAR*, TCHAR*, DB_FEATURELIST*);
	U32 RightsQueryNuserUser(TCHAR*, TCHAR*, TCHAR*, DB_FEATURELIST*);
	AMRETURN RightsQueryNext(U32 num, DB_FEATURELIST *p, U32 *n);
	ROLE RightsGrupUser(U32, U32);
	ROLE RightsQueryRaw(U32, U32, U32, U32);
	U32 m_batch;
	U32 m_records;
	U32 m_confirmAccessStatus;
	DB_FEATURELIST m_denyList;

	AMRETURN CreatePolicyTable();
	AMRETURN DropPolicyTable();
	AMRETURN DropConnectionTable();
	AMRETURN CreateConnectionTable();
	AMRETURN DropEventLogTable();
	AMRETURN CreateEventLogTable();

	AMRETURN CreateGuestTable();
	AMRETURN DropGuestTable();
	AMRETURN CreateGuestGroupTable();
	AMRETURN DropGuestGroupTable();
	AMRETURN CreateGuestGroupMemberTable();
	AMRETURN DropGuestGroupMemberTable();

	AMRETURN CreateHostTable();
	AMRETURN DropHostTable();
	AMRETURN CreateHostGroupTable();
	AMRETURN DropHostGroupTable();
	AMRETURN CreateHostGroupMemberTable();
	AMRETURN DropHostGroupMemberTable();

	AMRETURN CreateNtuserTable();
	AMRETURN DropNtuserTable();
	AMRETURN CreateNtgroupTable();
	AMRETURN DropNtgroupTable();
	AMRETURN CreateWkstTable();
	AMRETURN DropWkstTable();
	AMRETURN CreateDomTable();
	AMRETURN DropDomTable();

	AMRETURN CreateServerTable();
	AMRETURN DropServerTable();

	AMRETURN CreateBatchTable();
	AMRETURN DropBatchTable();
	AMRETURN CreateRoleTable();
	AMRETURN DropRoleTable();
	AMRETURN CreateTodoTable();
	AMRETURN DropTodoTable();
	AMRETURN CreateDoneTable();
	AMRETURN DropDoneTable();
	AMRETURN PolicySetInternal(TCHAR*, TCHAR*);
	AMRETURN PolicyInsertInternal(TCHAR*, TCHAR*);
public:
	TCHAR* Uppercase(TCHAR*);
	AMRETURN FormatMD5(TCHAR*, TCHAR*);
	AMRETURN FormatMD5noNull(TCHAR*, TCHAR*);
	AMRETURN PolicySet(TCHAR*, TCHAR*);
	AMRETURN PolicyGet(TCHAR*, TCHAR*);
	AMRETURN CreateMainTable();
	AMRETURN DropMainTable();
};

#endif // !defined(AFX_AMCONNECTION_H__E4AEE478_0C48_11D4_BD6C_329F76000000__INCLUDED_)
